#include<fem.hpp>
using namespace ngfem;
extern "C" {
void CompiledEvaluate(BaseMappedIntegrationRule & mir, BareSliceMatrix<double> results ) {

[[maybe_unused]] auto points = mir.GetPoints();
[[maybe_unused]] auto domain_index = mir.GetTransformation().GetElementIndex();
for ( auto i : Range(mir)) {
[[maybe_unused]] auto & ip = mir[i];
auto var_0 = points(i,0);
double var_1;
var_1 = 0x1p+0 /* (1.0000000000000000e+00) */;
auto var_2 = var_1 - var_0;
auto var_3 = var_0 * var_2;
auto var_4 = points(i,1);
auto var_5 = var_3 * var_4;
auto var_6 = var_5 * var_5;
auto var_7 = var_5 * var_3;
auto var_8 = var_6 + var_7;
auto var_9 = var_3 * var_3;
auto var_10 = var_8 + var_9;
auto var_11 = var_10 * var_10;
auto var_12 = var_11 * var_10;
auto var_13 = var_3 * var_3;
auto var_14 = var_12 * var_13;
auto var_15 = var_10 * var_10;
auto var_16 = var_3 * var_15;
auto var_17 = var_14 + var_16;
auto var_18 = var_3 * var_3;
auto var_19 = var_17 + var_18;
auto var_20 = var_5 * var_5;
auto var_21 = var_19 + var_20;
auto var_22 = var_10 * var_10;
auto var_23 = var_21 + var_22;
auto var_24 = var_23 + var_23;
auto var_25 = var_24 + var_23;
double var_26;
var_26 = var_25;
results(i,0) =var_26;

}
}

void CompiledEvaluateSIMD(SIMD_BaseMappedIntegrationRule & mir, BareSliceMatrix<SIMD<double>> results ) {

[[maybe_unused]] auto points = mir.GetPoints();
[[maybe_unused]] auto domain_index = mir.GetTransformation().GetElementIndex();
for ( auto i : Range(mir)) {
[[maybe_unused]] auto & ip = mir[i];
auto var_0 = points(i,0);
SIMD<double> var_1;
var_1 = 0x1p+0 /* (1.0000000000000000e+00) */;
auto var_2 = var_1 - var_0;
auto var_3 = var_0 * var_2;
auto var_4 = points(i,1);
auto var_5 = var_3 * var_4;
auto var_6 = var_5 * var_5;
auto var_7 = var_5 * var_3;
auto var_8 = var_6 + var_7;
auto var_9 = var_3 * var_3;
auto var_10 = var_8 + var_9;
auto var_11 = var_10 * var_10;
auto var_12 = var_11 * var_10;
auto var_13 = var_3 * var_3;
auto var_14 = var_12 * var_13;
auto var_15 = var_10 * var_10;
auto var_16 = var_3 * var_15;
auto var_17 = var_14 + var_16;
auto var_18 = var_3 * var_3;
auto var_19 = var_17 + var_18;
auto var_20 = var_5 * var_5;
auto var_21 = var_19 + var_20;
auto var_22 = var_10 * var_10;
auto var_23 = var_21 + var_22;
auto var_24 = var_23 + var_23;
auto var_25 = var_24 + var_23;
SIMD<double> var_26;
var_26 = var_25;
results(0,i) =var_26;

}
}

void CompiledEvaluateDeriv(BaseMappedIntegrationRule & mir, BareSliceMatrix<AutoDiff<1,double>> results ) {

[[maybe_unused]] auto points = mir.GetPoints();
[[maybe_unused]] auto domain_index = mir.GetTransformation().GetElementIndex();
for ( auto i : Range(mir)) {
[[maybe_unused]] auto & ip = mir[i];
auto var_0 = points(i,0);
AutoDiff<1,double> var_1;
var_1 = 0x1p+0 /* (1.0000000000000000e+00) */;
auto var_2 = var_1 - var_0;
auto var_3 = var_0 * var_2;
auto var_4 = points(i,1);
auto var_5 = var_3 * var_4;
auto var_6 = var_5 * var_5;
auto var_7 = var_5 * var_3;
auto var_8 = var_6 + var_7;
auto var_9 = var_3 * var_3;
auto var_10 = var_8 + var_9;
auto var_11 = var_10 * var_10;
auto var_12 = var_11 * var_10;
auto var_13 = var_3 * var_3;
auto var_14 = var_12 * var_13;
auto var_15 = var_10 * var_10;
auto var_16 = var_3 * var_15;
auto var_17 = var_14 + var_16;
auto var_18 = var_3 * var_3;
auto var_19 = var_17 + var_18;
auto var_20 = var_5 * var_5;
auto var_21 = var_19 + var_20;
auto var_22 = var_10 * var_10;
auto var_23 = var_21 + var_22;
auto var_24 = var_23 + var_23;
auto var_25 = var_24 + var_23;
AutoDiff<1,double> var_26;
var_26 = var_25;
results(i,0) =var_26;

}
}

void CompiledEvaluateDerivSIMD(SIMD_BaseMappedIntegrationRule & mir, BareSliceMatrix<AutoDiff<1,SIMD<double>>> results ) {

[[maybe_unused]] auto points = mir.GetPoints();
[[maybe_unused]] auto domain_index = mir.GetTransformation().GetElementIndex();
for ( auto i : Range(mir)) {
[[maybe_unused]] auto & ip = mir[i];
auto var_0 = points(i,0);
AutoDiff<1,SIMD<double>> var_1;
var_1 = 0x1p+0 /* (1.0000000000000000e+00) */;
auto var_2 = var_1 - var_0;
auto var_3 = var_0 * var_2;
auto var_4 = points(i,1);
auto var_5 = var_3 * var_4;
auto var_6 = var_5 * var_5;
auto var_7 = var_5 * var_3;
auto var_8 = var_6 + var_7;
auto var_9 = var_3 * var_3;
auto var_10 = var_8 + var_9;
auto var_11 = var_10 * var_10;
auto var_12 = var_11 * var_10;
auto var_13 = var_3 * var_3;
auto var_14 = var_12 * var_13;
auto var_15 = var_10 * var_10;
auto var_16 = var_3 * var_15;
auto var_17 = var_14 + var_16;
auto var_18 = var_3 * var_3;
auto var_19 = var_17 + var_18;
auto var_20 = var_5 * var_5;
auto var_21 = var_19 + var_20;
auto var_22 = var_10 * var_10;
auto var_23 = var_21 + var_22;
auto var_24 = var_23 + var_23;
auto var_25 = var_24 + var_23;
AutoDiff<1,SIMD<double>> var_26;
var_26 = var_25;
results(0,i) =var_26;

}
}

void CompiledEvaluateDDeriv(BaseMappedIntegrationRule & mir, BareSliceMatrix<AutoDiffDiff<1,double>> results ) {

[[maybe_unused]] auto points = mir.GetPoints();
[[maybe_unused]] auto domain_index = mir.GetTransformation().GetElementIndex();
for ( auto i : Range(mir)) {
[[maybe_unused]] auto & ip = mir[i];
auto var_0 = points(i,0);
AutoDiffDiff<1,double> var_1;
var_1 = 0x1p+0 /* (1.0000000000000000e+00) */;
auto var_2 = var_1 - var_0;
auto var_3 = var_0 * var_2;
auto var_4 = points(i,1);
auto var_5 = var_3 * var_4;
auto var_6 = var_5 * var_5;
auto var_7 = var_5 * var_3;
auto var_8 = var_6 + var_7;
auto var_9 = var_3 * var_3;
auto var_10 = var_8 + var_9;
auto var_11 = var_10 * var_10;
auto var_12 = var_11 * var_10;
auto var_13 = var_3 * var_3;
auto var_14 = var_12 * var_13;
auto var_15 = var_10 * var_10;
auto var_16 = var_3 * var_15;
auto var_17 = var_14 + var_16;
auto var_18 = var_3 * var_3;
auto var_19 = var_17 + var_18;
auto var_20 = var_5 * var_5;
auto var_21 = var_19 + var_20;
auto var_22 = var_10 * var_10;
auto var_23 = var_21 + var_22;
auto var_24 = var_23 + var_23;
auto var_25 = var_24 + var_23;
AutoDiffDiff<1,double> var_26;
var_26 = var_25;
results(i,0) =var_26;

}
}

void CompiledEvaluateDDerivSIMD(SIMD_BaseMappedIntegrationRule & mir, BareSliceMatrix<AutoDiffDiff<1,SIMD<double>>> results ) {

[[maybe_unused]] auto points = mir.GetPoints();
[[maybe_unused]] auto domain_index = mir.GetTransformation().GetElementIndex();
for ( auto i : Range(mir)) {
[[maybe_unused]] auto & ip = mir[i];
auto var_0 = points(i,0);
AutoDiffDiff<1,SIMD<double>> var_1;
var_1 = 0x1p+0 /* (1.0000000000000000e+00) */;
auto var_2 = var_1 - var_0;
auto var_3 = var_0 * var_2;
auto var_4 = points(i,1);
auto var_5 = var_3 * var_4;
auto var_6 = var_5 * var_5;
auto var_7 = var_5 * var_3;
auto var_8 = var_6 + var_7;
auto var_9 = var_3 * var_3;
auto var_10 = var_8 + var_9;
auto var_11 = var_10 * var_10;
auto var_12 = var_11 * var_10;
auto var_13 = var_3 * var_3;
auto var_14 = var_12 * var_13;
auto var_15 = var_10 * var_10;
auto var_16 = var_3 * var_15;
auto var_17 = var_14 + var_16;
auto var_18 = var_3 * var_3;
auto var_19 = var_17 + var_18;
auto var_20 = var_5 * var_5;
auto var_21 = var_19 + var_20;
auto var_22 = var_10 * var_10;
auto var_23 = var_21 + var_22;
auto var_24 = var_23 + var_23;
auto var_25 = var_24 + var_23;
AutoDiffDiff<1,SIMD<double>> var_26;
var_26 = var_25;
results(0,i) =var_26;

}
}

}
